Loading...
Searching...
No Matches
SalesforceRestClient::SalesforceRestConnection Class Reference

class for Salesforce.com REST connections; returns SalesforceRestClient::SalesforceRestClient objects More...

Inheritance diagram for SalesforceRestClient::SalesforceRestConnection:
[legend]

## Public Member Functions

| constructor (string name, string description, string url, hash< auto > attributes={}, hash< auto > options={})
| creates the SalesforceRestConnection connection object
DataProvider::AbstractDataProvider | getDataProvider ()
| returns a data provider object for this connection
string | getOAuth2OptionName (string opt)
| Returns the OAuth2 option name for this connection.
hash< auto > | getOAuth2Options ()
| Returns OAuth2 options in a standard format.
string | getType ()
| returns `"sfrests"`
bool | hasDataProvider ()
| returns True as this connection returns a data provider with the getDataProvider() method
Qore::AbstractPollOperation | startPollConnect ()
| Called to start a non-blocking polling ping operation on the remote REST server.

## Public Attributes

const | ConnectionScheme
| Connection entry info.
const | OAuth2AuthRequestOptions = ...
| options required to support the OAuth2 authorization code grant flow
const | OAuth2DifferentOptionMap = map {$1.value: $1.key}
| Different OAuth2 option map; standard name => extern name.
const | OAuth2Options
| Maps Salesforce REST options to standard options.
const | OAuth2StandardToSalesforceOptionMap = map {$1.value: $1.key}
| Maps standard option names to Salesforce REST option names.

## Protected Member Functions

| checkAuthCodeFeature ()
| Sets the auth code feature if supported.
hash< ConnectionSchemeInfo > | getConnectionSchemeInfoImpl ()
| Returns the ConnectionSchemeInfo hash for this object.
SalesforceRestClient | getImpl (bool connect=True, *hash< auto > rtopts)
| returns a SalesforceRestClient::SalesforceRestClient object
*hash< auto > | processOAuth2TokenResponseImpl (hash< auto > resp)
| Processes OAuth2 login responses and returns updated options.
| setChildCapabilities ()
| Sets child data provider capabilities.

## Detailed Description

class for Salesforce.com REST connections; returns SalesforceRestClient::SalesforceRestClient objects

In addition to all options supported by RestClientConnection, this connection class supports the following options:

- `api:` the Salesforce.com API to use; use `"auto"` (the default) to use the latest API version
- `client_id:` (required) the Salesforce.com "consumer key" for the Connected App
- `client_secret:` (required) the Salesforce.com "consumer secret" for the Connected App
- `oauth_url_auth:` default value `"https://login.salesforce.com/services/oauth2/authorize"`
- `oauth_url_token:` default value `"https://login.salesforce.com/services/oauth2/token"` (used for logging in to Salesforce.com)
- `oauth_url_revoke:` default value `"https://login.salesforce.com/services/oauth2/revoke"`

See also
  SalesforceRestClient::constructor() for more information on the above options

Since
  SalesforceRestConnection 1.1

## Member Function Documentation

## constructor()

SalesforceRestClient::SalesforceRestConnection::constructor | ( | string | name,
|  | string | description,
|  | string | url,
|  | hash< auto > | attributes = `{}`,
|  | hash< auto > | options = `{}`
| ) |  |

creates the SalesforceRestConnection connection object

Parameters

  name | the name of the connection
  description | connection description
  url | connection URL (potentially with password info)
  attributes | various attributes. See below
  options | connection options

See AbstractConnection::constructor() for `attributes` and `options` reference.

## getDataProvider()

DataProvider::AbstractDataProvider SalesforceRestClient::SalesforceRestConnection::getDataProvider | ( |  | ) |

returns a data provider object for this connection

Returns
  a data provider object for this connection

Exceptions

  DATA-PROVIDER-ERROR | this object does not support the data provider API

## getImpl()

SalesforceRestClient SalesforceRestClient::SalesforceRestConnection::getImpl | ( | bool | connect = `True`,
|  | *hash< auto > | rtopts
| ) |  |

protected

returns a SalesforceRestClient::SalesforceRestClient object

Parameters

  connect | if True, then the connection is returned already connected
  rtopts | this connection type does not accept any runtime options, so this parameter is ignored

Returns
  a SalesforceRestClient object

## getOAuth2OptionName()

string SalesforceRestClient::SalesforceRestConnection::getOAuth2OptionName | ( | string | opt | ) |

Returns the OAuth2 option name for this connection.

Since
  SalesforceRestClient 2.0

## getOAuth2Options()

hash< auto > SalesforceRestClient::SalesforceRestConnection::getOAuth2Options | ( |  | ) |

Returns OAuth2 options in a standard format.

Since
  SalesforceRestClient 2.0

## hasDataProvider()

bool SalesforceRestClient::SalesforceRestConnection::hasDataProvider | ( |  | ) |

returns True as this connection returns a data provider with the getDataProvider() method

Returns
  True as this connection returns a data provider with the getDataProvider() method

See also
  getDataProvider()

## startPollConnect()

Qore::AbstractPollOperation SalesforceRestClient::SalesforceRestConnection::startPollConnect | ( |  | ) |

Called to start a non-blocking polling ping operation on the remote REST server.

Returns
  a socket poll operation object that will allow the connection goal to be reached with polling

See also
  supportsPollingApi()